package fr.nitorac.aurionweb.fragments.results;

import android.util.Log;
import android.webkit.WebView;
import android.widget.Toast;

import java.io.IOException;
import java.security.GeneralSecurityException;

import fr.nitorac.aurionweb.aurionweb.AurionManager;
import fr.nitorac.aurionweb.aurionweb.AurionSession;
import fr.nitorac.aurionweb.fragments.AurionViewFragment;
import fr.nitorac.aurionweb.fragments.home.HomeFragment;

public class ResultsFragment extends AurionViewFragment {

    public static final String AURION_RES_URL = "https://aurionweb.ensiie.fr/faces/LearnerNotationListPage.xhtml";
    private boolean failed = false;

    @Override
    public void pageFinished(WebView view, String url) {
        view.evaluateJavascript("$('#form\\\\:headerSubview\\\\:header,.divCurrentUser,.CardBigTopic,.EmptyBox20.cacherImpression').remove();$('#layout-container').css('padding-top', '0rem');$('.CardBigTopic').remove();$('.ui-column-title:contains(Date)').map(function(){return $(this).parent();}).get().forEach(function(e){ $(e).remove();});$('head').append('<style type=\"text/css\">.learnerNotationListPage .dataTable td { white-space: initial; }</style>');var grades = $('td > .ui-column-title:contains(Code)').map(function(){return {'id':$(this).parent().contents().get(1).nodeValue, 'el':$(this).parent().parent()[0]};}).get().sort(function(a,b){var an = parseInt(a['id'].replace(/(^.+?)(\\d+).*$/i,'$2'));var bn = parseInt(b['id'].replace(/(^.+?)(\\d+).*$/i,'$2'));return an==bn?a['id'].localeCompare(b['id']):bn-an;});var table = $('tbody.ui-datatable-data')[0];table.innerHTML='';grades.forEach(function(e){table.append(e['el'])});", paRes -> {});
    }

    @Override
    public void networkInit(AurionSession session) {
        try {
            AurionManager.getInstance().initResultsSection(currentSession);
            AurionManager.getInstance().reachMyResultsFromInit(currentSession);
        } catch (IOException | GeneralSecurityException e) {
            e.printStackTrace();
            failed = true;
            Log.e(getClass().getSimpleName(), "Impossible de charger le chemin vers les résultats (" + e.getLocalizedMessage() + ")");
            if(getActivity() != null){
                getActivity().runOnUiThread(() -> {
                    Toast.makeText(getContext(), "Impossible de charger le chemin vers les résultats (" + e.getLocalizedMessage() + ")", Toast.LENGTH_LONG).show();
                    webView.loadUrl(HomeFragment.AURIONURL, getHeaders());
                });
            }

        }
    }

    @Override
    public void preload() {
        if(!failed){
            webView.loadUrl(AURION_RES_URL, getHeaders());
        }
    }
}